glibmm: Gio::UnixSocketAddress Class Reference

glibmm 2.32.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gio::UnixSocketAddress Class Reference
Portable Network I/O Functionality

UnixSocketAddress - UNIX SocketAddress. More...

`#include <giomm/unixsocketaddress.h>`

Inheritance diagram for Gio::UnixSocketAddress:
[legend]

List of all members.

## Public Member Functions
virtual | ~UnixSocketAddress ()
GUnixSocketAddress* | gobj ()
| Provides access to the underlying C GObject.
const GUnixSocketAddress* | gobj () const
| Provides access to the underlying C GObject.
GUnixSocketAddress* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
UnixSocketAddressType | get_address_type () const
| Gets address's type.
std::string | get_path () const
| Gets address's path, or for abstract sockets the "name".
Glib::PropertyProxy_ReadOnly < bool > | property_abstract () const
| Whether or not this is an abstract address.
Glib::PropertyProxy_ReadOnly < UnixSocketAddressType > | property_address_type () const
| The type of UNIX socket address.
Glib::PropertyProxy_ReadOnly < std::string > | property_path () const
| UNIX socket path.
Public Member Functions inherited from Gio::SocketAddress
virtual | ~SocketAddress ()
SocketFamily | get_family () const
| Gets the socket family type of address.
bool | to_native (gpointer dest, gsize destlen)
| Converts a SocketAddress to a native <type>struct sockaddr</type>, which can be passed to low-level functions like connect() or bind().
gssize | get_native_size () const
| Gets the size of address's native <type>struct sockaddr</type>.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< SocketFamily > > | property_family () const
| The family of the socket address.
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()
Public Member Functions inherited from Gio::SocketConnectable
virtual | ~SocketConnectable ()
Glib::RefPtr < SocketAddressEnumerator > | enumerate ()
| Creates a SocketAddressEnumerator for connectable.
Glib::RefPtr< const SocketAddressEnumerator > | enumerate () const
| Creates a SocketAddressEnumerator for connectable.
Glib::RefPtr < SocketAddressEnumerator > | proxy_enumerate ()
| Creates a SocketAddressEnumerator for connectable that will return ProxyAddresses for addresses that you must connect to via a proxy.
Glib::RefPtr< const SocketAddressEnumerator > | proxy_enumerate () const
| Creates a SocketAddressEnumerator for connectable that will return ProxyAddresses for addresses that you must connect to via a proxy.
Public Member Functions inherited from Glib::Interface
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes.
| Interface (GObject* castitem)
| Called by constructors of derived classes.
virtual | ~Interface ()

## Static Public Member Functions
static Glib::RefPtr < UnixSocketAddress > | create (const std::string& path)
| Creates a new UnixSocketAddress for path.
static Glib::RefPtr < UnixSocketAddress > | create (const std::string& path, UnixSocketAddressType type=Gio::UNIX_SOCKET_ADDRESS_ABSTRACT, int path_len=-1)
| Creates a new UnixSocketAddress of type type with name path.
static bool | abstract_names_supported ()
| Checks if abstract unix domain socket names are supported.
Static Public Member Functions inherited from Gio::SocketAddress
static Glib::RefPtr < SocketAddress > | create (gpointer native, gsize len)
Static Public Member Functions inherited from Gio::SocketConnectable
static void | add_interface (GType gtype_implementer)

## Protected Member Functions
| UnixSocketAddress (const std::string& path)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::UnixSocketAddress > | wrap (GUnixSocketAddress* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::SocketAddress
Glib::RefPtr< Gio::SocketAddress > | wrap (GSocketAddress* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::SocketConnectable
Glib::RefPtr < Gio::SocketConnectable > | wrap (GSocketConnectable* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

UnixSocketAddress - UNIX SocketAddress.

Support for UNIX-domain (also known as local) sockets.

UNIX domain sockets are generally visible in the filesystem. However, some systems support abstract socket names which are not visible in the filesystem and not affected by the filesystem permissions, visibility, etc. Currently this is only supported under Linux. If you attempt to use abstract sockets on other systems, function calls may return Gio::IO_ERROR_NOT_SUPPORTED errors. You can use Gio::UnixSocketAddress::abstract_names_supported() to see if abstract names are supported.

Note that `<giomm/unixsocketaddress.h>` belongs to the UNIX-specific GIO interfaces.

Since glibmm 2.28:

## Constructor & Destructor Documentation

virtual Gio::UnixSocketAddress::~UnixSocketAddress | ( |  | ) |
| virtual

Gio::UnixSocketAddress::UnixSocketAddress | ( | const std::string & | path | ) |
| explicitprotected

## Member Function Documentation

static bool Gio::UnixSocketAddress::abstract_names_supported | ( |  | ) |
| static

Checks if abstract unix domain socket names are supported.

Since glibmm 2.22:

Returns:
  `true` if supported, `false` otherwise.

static Glib::RefPtr<UnixSocketAddress> Gio::UnixSocketAddress::create | ( | const std::string & | path | ) |
| static

Creates a new UnixSocketAddress for path.

To create abstract socket addresses, on systems that support that, use g_unix_socket_address_new_abstract().

Since glibmm 2.22:

Parameters:

  path | The socket path.

Returns:
  A new UnixSocketAddress.

static Glib::RefPtr<UnixSocketAddress> Gio::UnixSocketAddress::create | ( | const std::string & | path,
|  | UnixSocketAddressType | type = `Gio::UNIX_SOCKET_ADDRESS_ABSTRACT`,
|  | int | path_len = `-1`
| ) |  |
| static

Creates a new UnixSocketAddress of type type with name path.

If type is UNIX_SOCKET_ADDRESS_PATH, this is equivalent to calling g_unix_socket_address_new().

If path_type is UNIX_SOCKET_ADDRESS_ABSTRACT, then path_len bytes of path will be copied to the socket's path, and only those bytes will be considered part of the name. (If path_len is -1, then path is assumed to be NUL-terminated.) For example, if path was "test", then calling g_socket_address_get_native_size() on the returned socket would return 7 (2 bytes of overhead, 1 byte for the abstract-socket indicator byte, and 4 bytes for the name "test").

If path_type is UNIX_SOCKET_ADDRESS_ABSTRACT_PADDED, then path_len bytes of path will be copied to the socket's path, the rest of the path will be padded with 0 bytes, and the entire zero-padded buffer will be considered the name. (As above, if path_len is -1, then path is assumed to be NUL-terminated.) In this case, g_socket_address_get_native_size() will always return the full size of a `struct sockaddr_un`, although g_unix_socket_address_get_path_len() will still return just the length of path.

UNIX_SOCKET_ADDRESS_ABSTRACT is preferred over UNIX_SOCKET_ADDRESS_ABSTRACT_PADDED for new programs. Of course, when connecting to a server created by another process, you must use the appropriate type corresponding to how that process created its listening socket.

Since glibmm 2.26:

Parameters:

  path | The name.
  path_len | The length of path, or -1.
  type | A UnixSocketAddressType.

Returns:
  A new UnixSocketAddress.

UnixSocketAddressType Gio::UnixSocketAddress::get_address_type | ( |  | ) | const

Gets address's type.

Since glibmm 2.26:

Returns:
  A UnixSocketAddressType.

std::string Gio::UnixSocketAddress::get_path | ( |  | ) | const

Gets address's path, or for abstract sockets the "name".

Guaranteed to be zero-terminated, but an abstract socket may contain embedded zeros, and thus you should use g_unix_socket_address_get_path_len() to get the true length of this string.

Since glibmm 2.22:

Returns:
  The path for address.

GUnixSocketAddress* Gio::UnixSocketAddress::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketAddress.

const GUnixSocketAddress* Gio::UnixSocketAddress::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketAddress.

GUnixSocketAddress* Gio::UnixSocketAddress::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::SocketAddress.

Glib::PropertyProxy_ReadOnly< bool > Gio::UnixSocketAddress::property_abstract | ( |  | ) | const

Whether or not this is an abstract address.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< UnixSocketAddressType > Gio::UnixSocketAddress::property_address_type | ( |  | ) | const

The type of UNIX socket address.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< std::string > Gio::UnixSocketAddress::property_path | ( |  | ) | const

UNIX socket path.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::UnixSocketAddress > wrap | ( | GUnixSocketAddress * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.